from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="ComponentsschemasJsonTypeBeanConfiguration")


@attr.s(auto_attribs=True)
class ComponentsschemasJsonTypeBeanConfiguration:
    """ If the field is a custom field, the configuration of the field. """

    additional_properties: Dict[str, None] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:

        field_dict: Dict[str, Any] = {}
        for prop_name, prop in self.additional_properties.items():
            field_dict[prop_name] = None

        field_dict.update({})

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        componentsschemas_json_type_bean_configuration = cls()

        additional_properties = {}
        for prop_name, prop_dict in d.items():
            additional_property = None

            additional_properties[prop_name] = additional_property

        componentsschemas_json_type_bean_configuration.additional_properties = additional_properties
        return componentsschemas_json_type_bean_configuration

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> None:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: None) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
